﻿// <auto-generated> This file has been auto generated by EF Core Power Tools. </auto-generated>
#nullable disable
using System;
using System.Collections.Generic;

namespace iLoan.Rules.Models;

/// <summary>
/// Rule that can be assessed as part of the application flow
/// </summary>
public partial class CoreRule
{
    /// <summary>
    /// Internal identifier of the rule record
    /// </summary>
    public int Id { get; set; }

    /// <summary>
    /// The name of the rule
    /// </summary>
    public string RuleName { get; set; }

    /// <summary>
    /// The source of the rule
    /// </summary>
    public string Source { get; set; }

    /// <summary>
    /// Default threshold to apply to the rule
    /// </summary>
    public decimal? DefaultThreshold { get; set; }

    /// <summary>
    /// Indication if the rule blocks the application
    /// </summary>
    public bool Blocked { get; set; }

    /// <summary>
    /// Indication if the rule triggers a required manual review
    /// </summary>
    public bool TriggersManualReview { get; set; }

    /// <summary>
    /// Explanation on what the suggested resolution is to resolve a review
    /// </summary>
    public string SuggestedResolution { get; set; }

    /// <summary>
    /// Explanation on what the reason is for a triggered review
    /// </summary>
    public string TriggerReason { get; set; }

    /// <summary>
    /// Indication if the last record should be used if multiple records exist
    /// </summary>
    public bool? UseLastRecord { get; set; }

    /// <summary>
    /// The type of applicant the rule applies to
    /// </summary>
    public string ApplicantType { get; set; }

    /// <summary>
    /// The filter to apply when the rule is clicked in the rule summary
    /// </summary>
    public string FilterOnClickthrough { get; set; }

    /// <summary>
    /// Specifies the step before which this rule needs to be assessed
    /// </summary>
    public string RunBeforeStatus { get; set; }

    /// <summary>
    /// Section in which to display the rule
    /// </summary>
    public string DisplaySection { get; set; }

    /// <summary>
    /// Field to trigger a warning for when the rule gives a fail or review
    /// </summary>
    public string WarningField { get; set; }

    /// <summary>
    /// The Dutch name of the rule
    /// </summary>
    public string DutchRuleName { get; set; }

    /// <summary>
    /// The Dutch explanation on what the reason is for the triggered review
    /// </summary>
    public string DutchTriggerReason { get; set; }

    /// <summary>
    /// The Dutch explanation on what the suggested resolution is to resolve a review
    /// </summary>
    public string DutchSuggestedResolution { get; set; }

    /// <summary>
    /// The filter to apply when the rule is clicked in the rule summary when the user&apos;s language is set to Dutch
    /// </summary>
    public string DutchFilterOnClickthrough { get; set; }

    /// <summary>
    /// The additional explanation of the rule
    /// </summary>
    public string RuleExplanation { get; set; }

    /// <summary>
    /// The additional explanation of the rule in Dutch
    /// </summary>
    public string DutchRuleExplanation { get; set; }

    public decimal? WorkItemId { get; set; }

    public string Title { get; set; }

    public string Update { get; set; }

    public virtual ICollection<CoreRuleCriterion> CoreRuleCriteria { get; set; } = new List<CoreRuleCriterion>();

    public virtual ICollection<CoreRuleCriteriaOperator> CoreRuleCriteriaOperators { get; set; } = new List<CoreRuleCriteriaOperator>();
}