using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.JSInterop;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Web;
using Radzen;
using Radzen.Blazor;
using ILoan.Rules.Web.Models.Rules;

namespace ILoan.Rules.Web.Components.Pages
{
    public partial class EditCoreRuleCriteriaOperator
    {
        [Inject]
        protected IJSRuntime JSRuntime { get; set; }

        [Inject]
        protected NavigationManager NavigationManager { get; set; }

        [Inject]
        protected DialogService DialogService { get; set; }

        [Inject]
        protected TooltipService TooltipService { get; set; }

        [Inject]
        protected ContextMenuService ContextMenuService { get; set; }

        [Inject]
        protected NotificationService NotificationService { get; set; }
        [Inject]
        public RulesService RulesService { get; set; }

        [Parameter]
        public int ID { get; set; }

        protected override async Task OnInitializedAsync()
        {
            coreRuleCriteriaOperator = await RulesService.GetCoreRuleCriteriaOperatorById(ID);

            coreRulesForRuleID = await RulesService.GetCoreRules();
        }
        protected bool errorVisible;
        protected ILoan.Rules.Web.Models.Rules.CoreRuleCriteriaOperator coreRuleCriteriaOperator;

        protected IEnumerable<ILoan.Rules.Web.Models.Rules.CoreRule> coreRulesForRuleID;

        protected async Task FormSubmit()
        {
            try
            {
                coreRuleCriteriaOperator.Update += 1;
                await RulesService.UpdateCoreRuleCriteriaOperator(ID, coreRuleCriteriaOperator);
                DialogService.Close(coreRuleCriteriaOperator);
            }
            catch (Exception ex)
            {
                errorVisible = true;
            }
        }

        protected async Task CancelButtonClick(MouseEventArgs args)
        {
            DialogService.Close(null);
        }





        bool hasRuleIDValue;

        [Parameter]
        public int? RuleID { get; set; }
        public override async Task SetParametersAsync(ParameterView parameters)
        {
            coreRuleCriteriaOperator = new ILoan.Rules.Web.Models.Rules.CoreRuleCriteriaOperator();

            hasRuleIDValue = parameters.TryGetValue<int?>("RuleID", out var hasRuleIDResult);

            if (hasRuleIDValue)
            {
                coreRuleCriteriaOperator.RuleID = hasRuleIDResult;
            }
            await base.SetParametersAsync(parameters);
        }
    }
}